# simulateTransaction

Simulate sending a transaction.

This method will use `30` [Compute Units](https://docs.validationcloud.io/v1/about/billing).

***

## **Parameters**

* `transaction` string The transaction as an encoded string. The transaction must have a valid blockhash, but is not required to be signed.
* `object` *optional.* Configuration object containing the following fields:
  * `commitment` string. The level of commitment required for the query. The options include:
    * `finalized` string. The node will query the most recent block confirmed by the supermajority of the cluster as having reached maximum lockout, meaning the cluster has recognized this block as finalized.
    * `confirmed` string. The node will query the most recent block that has been voted on by the supermajority of the cluster.
    * `processed` string. The node will query its most recent block. Note that the block may not be complete.
  * `sigVerify` boolean (default: false) If true, the transaction signatures will be verified (conflicts with replaceRecentBlockhash).
  * `replaceRecentBlockhash` boolean (default: false) If true, the transaction recent blockhash will be replaced with the most recent blockhash (conflicts with sigVerify).
  * `encoding` string (default: base58) The encoding format for account data. It can be either base58 (slow, DEPRECATED) or base64.
  * `minContextSlot` integer. The minimum slot at which the request can be evaluated.
  * `innerInstructions` boolean (default: false) If true the response will include inner instructions. These inner instructions will be jsonParsed where possible, otherwise json.
  * `accounts` object The accounts configuration object containing the following fields:
    * `addresses` string An array of accounts to return, as base-58 encoded strings
    * `encoding` string The encoding format for account data. It can be one of base58 (slow), base64, base64+zstd or jsonParsed.

## Returns

`result` Null if the account doesn't exist otherwise RpcResponse JSON object with the following fields:

* `context` An object that contains metadata about the current state of the Solana network at the time the request was processed.
  * `apiVersion` The version number.
  * `slot` The current slot in the Solana cluster during which the transactions are processed and new blocks are added to the blockchain.
* `err` Error code if the transaction failed or null if the transaction succeeds.
* `logs` An array of log messages the transaction instructions output during execution, null if simulation failed before the transaction was able to execute (for example due to an invalid blockhash or signature verification failure).
* `accounts` An array of accounts with the same length as the accounts.addresses array in the request
  * `null` If the account doesn't exist or if err is not null.
  * `object` otherwise, a JSON object containing:
    * `lamports` The number of lamports assigned to this account as u64 (64-bit unsigned integer).
    * `owner` The base-58 encoded Pubkey of the program this account has been assigned to.
    * `data` The data associated with the account, either as encoded binary data or JSON format {'program': 'state'}, depending on encoding parameter.
    * `executable` A boolean indicating if the account contains a program (and is strictly read-only).
    * `rentEpoch` The epoch at which this account will next owe rent, as u64 (64-bit unsigned integer).
* `unitsConsumed` The number of compute budget units consumed during the processing of this transaction.
* `returnData` The most-recent return data generated by an instruction in the transaction, with the following fields:
  * `programId` string The program that generated the return data, as base-58 encoded Pubkey.
  * `data` The return data itself, as base-64 encoded binary data.
* `innerInstructions` The value is a list of inner instructions.

```bash
// Result
{
  "jsonrpc": "2.0",
  "result": {
    "context": {
      "slot": 218
    },
    "value": {
      "err": null,
      "accounts": null,
      "logs": [
        "Program 83astBRguLMdt2h5U1Tpdq5tjFoJ6noeGwaY3mDLVcri invoke [1]",
        "Program 83astBRguLMdt2h5U1Tpdq5tjFoJ6noeGwaY3mDLVcri consumed 2366 of 1400000 compute units",
        "Program return: 83astBRguLMdt2h5U1Tpdq5tjFoJ6noeGwaY3mDLVcri KgAAAAAAAAA=",
        "Program 83astBRguLMdt2h5U1Tpdq5tjFoJ6noeGwaY3mDLVcri success"
      ],
      "returnData": {
        "data": ["Kg==", "base64"],
        "programId": "83astBRguLMdt2h5U1Tpdq5tjFoJ6noeGwaY3mDLVcri"
      },
      "unitsConsumed": 2366
    }
  },
  "id": 1
}
```

{% tabs %}
{% tab title="mainnet" %}

<pre class="language-bash"><code class="lang-bash"><strong>curl https://mainnet.solana.validationcloud.io/v1/&#x3C;YOUR_API_KEY_HERE> \
</strong>    -X POST \
    -H "Content-Type: application/json" \
    -d '{"method":"simulateTransaction","params":["ENTER_ENCODED_TRANSACTION_ID"],"id":1,"jsonrpc":"2.0"}'
    
</code></pre>

{% endtab %}

{% tab title="devnet" %}

```bash
curl https://devnet.solana.validationcloud.io/v1/<YOUR_API_KEY_HERE> \
    -X POST \
    -H "Content-Type: application/json" \
    -d '{"method":"simulateTransaction","params":["ENTER_ENCODED_TRANSACTION_ID"],"id":1,"jsonrpc":"2.0"}'
    
```

{% endtab %}
{% endtabs %}
